##############################################################################
##
## ***************************************************************************
## **                                                                       **
## ** Copyright (c) 1995-2010 Xilinx, Inc.  All rights reserved.            **
## **                                                                       **
## ** You may copy and modify these files for your own internal use solely  **
## ** with Xilinx programmable logic devices and Xilinx EDK system or       **
## ** create IP modules solely for Xilinx programmable logic devices and    **
## ** Xilinx EDK system. No rights are granted to distribute any files      **
## ** unless they are distributed in Xilinx programmable logic devices.     **
## **                                                                       **
## ***************************************************************************
##
##############################################################################

proc generate {drv_handle} {
    puts "Generating Macros for w2_warplab_buffers_plbw driver access ... "

    # initialize
    lappend config_table
    lappend addr_config_table
    lappend xparam_config_table

    # hardware version
    lappend config_table "C_XC_VERSION"
    # Low-level function names
    lappend config_table "C_XC_CREATE" "C_XC_RELEASE" "C_XC_OPEN" "C_XC_CLOSE" "C_XC_READ" "C_XC_WRITE" "C_XC_GET_SHMEM"
    # Optional parameters
    # (empty)

    # Memory map information
    sg_lappend config_table addr_config_table "C_MEMMAP_AGCDONEADDR"
    sg_lappend config_table xparam_config_table "C_MEMMAP_AGCDONEADDR_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_AGCDONEADDR_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_AGCDONEADDR_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_CAPTUREDONE"
    sg_lappend config_table xparam_config_table "C_MEMMAP_CAPTUREDONE_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_CAPTUREDONE_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_CAPTUREDONE_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO1AGCDONERSSI"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1AGCDONERSSI_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1AGCDONERSSI_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1AGCDONERSSI_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO2AGCDONERSSI"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2AGCDONERSSI_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2AGCDONERSSI_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2AGCDONERSSI_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO3AGCDONERSSI"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3AGCDONERSSI_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3AGCDONERSSI_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3AGCDONERSSI_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO4AGCDONERSSI"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4AGCDONERSSI_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4AGCDONERSSI_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4AGCDONERSSI_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_DCO_EN_SEL"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DCO_EN_SEL_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DCO_EN_SEL_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_DCO_EN_SEL_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_DEBUGRX1BUFFERS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX1BUFFERS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX1BUFFERS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX1BUFFERS_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_DEBUGRX2BUFFERS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX2BUFFERS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX2BUFFERS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX2BUFFERS_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_DEBUGRX3BUFFERS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX3BUFFERS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX3BUFFERS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX3BUFFERS_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_DEBUGRX4BUFFERS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX4BUFFERS_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX4BUFFERS_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_DEBUGRX4BUFFERS_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_MGC_AGC_SEL"
    sg_lappend config_table xparam_config_table "C_MEMMAP_MGC_AGC_SEL_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_MGC_AGC_SEL_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_MGC_AGC_SEL_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO1RXBUFF_RXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1RXBUFF_RXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1RXBUFF_RXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1RXBUFF_RXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO1TXBUFF_TXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1TXBUFF_TXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1TXBUFF_TXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO1TXBUFF_TXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO2RXBUFF_RXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2RXBUFF_RXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2RXBUFF_RXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2RXBUFF_RXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO2TXBUFF_TXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2TXBUFF_TXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2TXBUFF_TXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO2TXBUFF_TXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO3RXBUFF_RXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3RXBUFF_RXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3RXBUFF_RXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3RXBUFF_RXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO3TXBUFF_TXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3TXBUFF_TXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3TXBUFF_TXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO3TXBUFF_TXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO4RXBUFF_RXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4RXBUFF_RXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4RXBUFF_RXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4RXBUFF_RXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RADIO4TXBUFF_TXEN"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4TXBUFF_TXEN_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4TXBUFF_TXEN_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RADIO4TXBUFF_TXEN_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_STARTCAPTURE"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STARTCAPTURE_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STARTCAPTURE_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_STARTCAPTURE_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_STARTTX"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STARTTX_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STARTTX_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_STARTTX_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_STOPTX"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STOPTX_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STOPTX_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_STOPTX_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_TRANSMODE"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TRANSMODE_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TRANSMODE_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TRANSMODE_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_TXDELAY"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXDELAY_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXDELAY_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXDELAY_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_TXLENGTH"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXLENGTH_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXLENGTH_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXLENGTH_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_STARTTXRX"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STARTTXRX_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_STARTTXRX_BIN_PT"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_STARTTXRX_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO1"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO1_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO1_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO1_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO1_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO1_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO1_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO2"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO2_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO2_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO2_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO2_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO2_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO2_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO3"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO3_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO3_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO3_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO3_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO3_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO3_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO4"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO4_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RXBUFF_RADIO4_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO4_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO4_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO4_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RXBUFF_RADIO4_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO1"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO1_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO1_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO1_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO1_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO1_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO1_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO2"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO2_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO2_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO2_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO2_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO2_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO2_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO3"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO3_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO3_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO3_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO3_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO3_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO3_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO4"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO4_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_TXBUFF_RADIO4_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO4_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO4_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO4_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_TXBUFF_RADIO4_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO1"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO1_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO1_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO1_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO1_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO1_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO1_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO2"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO2_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO2_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO2_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO2_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO2_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO2_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO3"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO3_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO3_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO3_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO3_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO3_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO3_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO4"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO4_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_RSSIBUFF_RADIO4_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO4_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO4_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO4_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_RSSIBUFF_RADIO4_ATTR"

    # XPS parameters
    sg_lappend config_table xparam_config_table "DEVICE_ID" "C_BASEADDR"

    # generate xparameters.h
    eval xdefine_include_file $drv_handle "xparameters.h" "W2_WARPLAB_BUFFERS_PLBW" "NUM_INSTANCES" ${xparam_config_table}
    eval sg_xdefine_include_file $drv_handle "xparameters.h" "W2_WARPLAB_BUFFERS_PLBW" ${addr_config_table}
    # generate w2_warplab_buffers_plbw_g.c
    eval xdefine_config_file $drv_handle "w2_warplab_buffers_plbw_g.c" "W2_WARPLAB_BUFFERS_PLBW" ${config_table}
}

proc sg_xdefine_include_file {drv_handle file_name drv_string args} {
    # Open include file
    set file_handle [xopen_include_file $file_name]

    # Get all peripherals connected to this driver
    set periphs [xget_periphs $drv_handle] 

    # Print all parameters for all peripherals
    set device_id 0
    foreach periph ${periphs} {
        # base_addr of the peripheral
        set base_addr [xget_param_value ${periph} "C_BASEADDR"]

        puts ${file_handle} ""
        puts ${file_handle} "/* Definitions (address parameters) for peripheral [string toupper [xget_hw_name $periph]] */"
        foreach arg ${args} {
            set value [xget_param_value ${periph} ${arg}]
            if {[llength ${value}] == 0} {
                set value 0
            }
            set value [expr ${base_addr} + ${value}]
            set value_str [xformat_address_string ${value}]
            puts ${file_handle} "#define [xget_name ${periph} ${arg}] ${value_str}"
        }

        puts $file_handle "/* software driver settings for peripheral [string toupper [xget_hw_name $periph]] */"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_VERSION   1"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_CREATE    xc_w2_warplab_buffers_plbw_create"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_RELEASE   xc_w2_warplab_buffers_plbw_release"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_OPEN      xc_w2_warplab_buffers_plbw_open"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_CLOSE     xc_w2_warplab_buffers_plbw_close"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_READ      xc_w2_warplab_buffers_plbw_read"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_WRITE     xc_w2_warplab_buffers_plbw_write"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_GET_SHMEM xc_w2_warplab_buffers_plbw_getshmem"

        puts $file_handle ""
    }		
    puts $file_handle "\n/******************************************************************/\n"
    close $file_handle
}

proc sg_lappend {required_config_table {extra_config_table ""} args} {
    upvar ${required_config_table} config_table_1
    if {[string length ${extra_config_table}] != 0} {
        upvar ${extra_config_table} config_table_2
    }

    foreach value ${args} {
        eval [list lappend config_table_1 ${value}]
        if {[string length ${extra_config_table}] != 0} {
            lappend config_table_2 ${value}
        }
    }
}
