
-------------------------------------------------------------------
-- System Generator version 13.4 VHDL source file.
--
-- Copyright(C) 2011 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
--
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
--
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
--
-- Any modifications that are made to the source code are done at the user's
-- sole risk and will be unsupported.
--
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2011 Xilinx, Inc.  All rights
-- reserved.
-------------------------------------------------------------------

-------------------------------------------------------------------
-- System Generator version 13.4 VHDL source file.
--
-- Copyright(C) 2011 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
--
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
--
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
--
-- Any modifications that are made to the source code are done at the user's
-- sole risk and will be unsupported.
--
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2011 Xilinx, Inc.  All rights
-- reserved.
-------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.conv_pkg.all;
-- synopsys translate_off
library unisim;
use unisim.vcomponents.all;
-- synopsys translate_on
entity xlclockdriver is
  generic (
    period: integer := 2;
    log_2_period: integer := 0;
    pipeline_regs: integer := 5;
    use_bufg: integer := 0
  );
  port (
    sysclk: in std_logic;
    sysclr: in std_logic;
    sysce: in std_logic;
    clk: out std_logic;
    clr: out std_logic;
    ce: out std_logic;
    ce_logic: out std_logic
  );
end xlclockdriver;
architecture behavior of xlclockdriver is
  component bufg
    port (
      i: in std_logic;
      o: out std_logic
    );
  end component;
  component synth_reg_w_init
    generic (
      width: integer;
      init_index: integer;
      init_value: bit_vector;
      latency: integer
    );
    port (
      i: in std_logic_vector(width - 1 downto 0);
      ce: in std_logic;
      clr: in std_logic;
      clk: in std_logic;
      o: out std_logic_vector(width - 1 downto 0)
    );
  end component;
  function size_of_uint(inp: integer; power_of_2: boolean)
    return integer
  is
    constant inp_vec: std_logic_vector(31 downto 0) :=
      integer_to_std_logic_vector(inp,32, xlUnsigned);
    variable result: integer;
  begin
    result := 32;
    for i in 0 to 31 loop
      if inp_vec(i) = '1' then
        result := i;
      end if;
    end loop;
    if power_of_2 then
      return result;
    else
      return result+1;
    end if;
  end;
  function is_power_of_2(inp: std_logic_vector)
    return boolean
  is
    constant width: integer := inp'length;
    variable vec: std_logic_vector(width - 1 downto 0);
    variable single_bit_set: boolean;
    variable more_than_one_bit_set: boolean;
    variable result: boolean;
  begin
    vec := inp;
    single_bit_set := false;
    more_than_one_bit_set := false;
    -- synopsys translate_off
    if (is_XorU(vec)) then
      return false;
    end if;
     -- synopsys translate_on
    if width > 0 then
      for i in 0 to width - 1 loop
        if vec(i) = '1' then
          if single_bit_set then
            more_than_one_bit_set := true;
          end if;
          single_bit_set := true;
        end if;
      end loop;
    end if;
    if (single_bit_set and not(more_than_one_bit_set)) then
      result := true;
    else
      result := false;
    end if;
    return result;
  end;
  function ce_reg_init_val(index, period : integer)
    return integer
  is
     variable result: integer;
   begin
      result := 0;
      if ((index mod period) = 0) then
          result := 1;
      end if;
      return result;
  end;
  function remaining_pipe_regs(num_pipeline_regs, period : integer)
    return integer
  is
     variable factor, result: integer;
  begin
      factor := (num_pipeline_regs / period);
      result := num_pipeline_regs - (period * factor) + 1;
      return result;
  end;

  function sg_min(L, R: INTEGER) return INTEGER is
  begin
      if L < R then
            return L;
      else
            return R;
      end if;
  end;
  constant max_pipeline_regs : integer := 8;
  constant pipe_regs : integer := 5;
  constant num_pipeline_regs : integer := sg_min(pipeline_regs, max_pipeline_regs);
  constant rem_pipeline_regs : integer := remaining_pipe_regs(num_pipeline_regs,period);
  constant period_floor: integer := max(2, period);
  constant power_of_2_counter: boolean :=
    is_power_of_2(integer_to_std_logic_vector(period_floor,32, xlUnsigned));
  constant cnt_width: integer :=
    size_of_uint(period_floor, power_of_2_counter);
  constant clk_for_ce_pulse_minus1: std_logic_vector(cnt_width - 1 downto 0) :=
    integer_to_std_logic_vector((period_floor - 2),cnt_width, xlUnsigned);
  constant clk_for_ce_pulse_minus2: std_logic_vector(cnt_width - 1 downto 0) :=
    integer_to_std_logic_vector(max(0,period - 3),cnt_width, xlUnsigned);
  constant clk_for_ce_pulse_minus_regs: std_logic_vector(cnt_width - 1 downto 0) :=
    integer_to_std_logic_vector(max(0,period - rem_pipeline_regs),cnt_width, xlUnsigned);
  signal clk_num: unsigned(cnt_width - 1 downto 0) := (others => '0');
  signal ce_vec : std_logic_vector(num_pipeline_regs downto 0);
  attribute MAX_FANOUT : string;
  attribute MAX_FANOUT of ce_vec:signal is "REDUCE";
  signal ce_vec_logic : std_logic_vector(num_pipeline_regs downto 0);
  attribute MAX_FANOUT of ce_vec_logic:signal is "REDUCE";
  signal internal_ce: std_logic_vector(0 downto 0);
  signal internal_ce_logic: std_logic_vector(0 downto 0);
  signal cnt_clr, cnt_clr_dly: std_logic_vector (0 downto 0);
begin
  clk <= sysclk;
  clr <= sysclr;
  cntr_gen: process(sysclk)
  begin
    if sysclk'event and sysclk = '1'  then
      if (sysce = '1') then
        if ((cnt_clr_dly(0) = '1') or (sysclr = '1')) then
          clk_num <= (others => '0');
        else
          clk_num <= clk_num + 1;
        end if;
    end if;
    end if;
  end process;
  clr_gen: process(clk_num, sysclr)
  begin
    if power_of_2_counter then
      cnt_clr(0) <= sysclr;
    else
      if (unsigned_to_std_logic_vector(clk_num) = clk_for_ce_pulse_minus1
          or sysclr = '1') then
        cnt_clr(0) <= '1';
      else
        cnt_clr(0) <= '0';
      end if;
    end if;
  end process;
  clr_reg: synth_reg_w_init
    generic map (
      width => 1,
      init_index => 0,
      init_value => b"0000",
      latency => 1
    )
    port map (
      i => cnt_clr,
      ce => sysce,
      clr => sysclr,
      clk => sysclk,
      o => cnt_clr_dly
    );
  pipelined_ce : if period > 1 generate
      ce_gen: process(clk_num)
      begin
          if unsigned_to_std_logic_vector(clk_num) = clk_for_ce_pulse_minus_regs then
              ce_vec(num_pipeline_regs) <= '1';
          else
              ce_vec(num_pipeline_regs) <= '0';
          end if;
      end process;
      ce_pipeline: for index in num_pipeline_regs downto 1 generate
          ce_reg : synth_reg_w_init
              generic map (
                  width => 1,
                  init_index => ce_reg_init_val(index, period),
                  init_value => b"0000",
                  latency => 1
                  )
              port map (
                  i => ce_vec(index downto index),
                  ce => sysce,
                  clr => sysclr,
                  clk => sysclk,
                  o => ce_vec(index-1 downto index-1)
                  );
      end generate;
      internal_ce <= ce_vec(0 downto 0);
  end generate;
  pipelined_ce_logic: if period > 1 generate
      ce_gen_logic: process(clk_num)
      begin
          if unsigned_to_std_logic_vector(clk_num) = clk_for_ce_pulse_minus_regs then
              ce_vec_logic(num_pipeline_regs) <= '1';
          else
              ce_vec_logic(num_pipeline_regs) <= '0';
          end if;
      end process;
      ce_logic_pipeline: for index in num_pipeline_regs downto 1 generate
          ce_logic_reg : synth_reg_w_init
              generic map (
                  width => 1,
                  init_index => ce_reg_init_val(index, period),
                  init_value => b"0000",
                  latency => 1
                  )
              port map (
                  i => ce_vec_logic(index downto index),
                  ce => sysce,
                  clr => sysclr,
                  clk => sysclk,
                  o => ce_vec_logic(index-1 downto index-1)
                  );
      end generate;
      internal_ce_logic <= ce_vec_logic(0 downto 0);
  end generate;
  use_bufg_true: if period > 1 and use_bufg = 1 generate
    ce_bufg_inst: bufg
      port map (
        i => internal_ce(0),
        o => ce
      );
    ce_bufg_inst_logic: bufg
      port map (
        i => internal_ce_logic(0),
        o => ce_logic
      );
  end generate;
  use_bufg_false: if period > 1 and (use_bufg = 0) generate
    ce <= internal_ce(0);
    ce_logic <= internal_ce_logic(0);
  end generate;
  generate_system_clk: if period = 1 generate
    ce <= sysce;
    ce_logic <= sysce;
  end generate;
end architecture behavior;

-------------------------------------------------------------------
-- System Generator version 13.4 VHDL source file.
--
-- Copyright(C) 2011 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
--
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
--
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
--
-- Any modifications that are made to the source code are done at the user's
-- sole risk and will be unsupported.
--
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2011 Xilinx, Inc.  All rights
-- reserved.
-------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
entity xland2 is
  port (
    a : in std_logic;
    b : in std_logic;
    dout : out std_logic
    );
end xland2;
architecture behavior of xland2 is
begin
    dout <= a and b;
end behavior;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

entity default_clock_driver is
  port (
    sysce: in std_logic; 
    sysce_clr: in std_logic; 
    sysclk: in std_logic; 
    ce_1: out std_logic; 
    ce_2: out std_logic; 
    clk_1: out std_logic; 
    clk_2: out std_logic
  );
end default_clock_driver;

architecture structural of default_clock_driver is
  attribute syn_noprune: boolean;
  attribute syn_noprune of structural : architecture is true;
  attribute optimize_primitives: boolean;
  attribute optimize_primitives of structural : architecture is false;
  attribute dont_touch: boolean;
  attribute dont_touch of structural : architecture is true;

  signal sysce_clr_x0: std_logic;
  signal sysce_x0: std_logic;
  signal sysclk_x0: std_logic;
  signal xlclockdriver_1_ce: std_logic;
  signal xlclockdriver_1_clk: std_logic;
  signal xlclockdriver_2_ce: std_logic;
  signal xlclockdriver_2_clk: std_logic;

begin
  sysce_x0 <= sysce;
  sysce_clr_x0 <= sysce_clr;
  sysclk_x0 <= sysclk;
  ce_1 <= xlclockdriver_1_ce;
  ce_2 <= xlclockdriver_2_ce;
  clk_1 <= xlclockdriver_1_clk;
  clk_2 <= xlclockdriver_2_clk;

  xlclockdriver_1: entity work.xlclockdriver
    generic map (
      log_2_period => 1,
      period => 1,
      use_bufg => 0
    )
    port map (
      sysce => sysce_x0,
      sysclk => sysclk_x0,
      sysclr => sysce_clr_x0,
      ce => xlclockdriver_1_ce,
      clk => xlclockdriver_1_clk
    );

  xlclockdriver_2: entity work.xlclockdriver
    generic map (
      log_2_period => 2,
      period => 2,
      use_bufg => 0
    )
    port map (
      sysce => sysce_x0,
      sysclk => sysclk_x0,
      sysclr => sysce_clr_x0,
      ce => xlclockdriver_2_ce,
      clk => xlclockdriver_2_clk
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

entity plb_clock_driver is
  port (
    sysce: in std_logic; 
    sysce_clr: in std_logic; 
    sysclk: in std_logic; 
    plb_ce_1: out std_logic; 
    plb_clk_1: out std_logic
  );
end plb_clock_driver;

architecture structural of plb_clock_driver is
  attribute syn_noprune: boolean;
  attribute syn_noprune of structural : architecture is true;
  attribute optimize_primitives: boolean;
  attribute optimize_primitives of structural : architecture is false;
  attribute dont_touch: boolean;
  attribute dont_touch of structural : architecture is true;

  signal sysce_clr_x0: std_logic;
  signal sysce_x0: std_logic;
  signal sysclk_x0: std_logic;
  signal xlclockdriver_1_ce: std_logic;
  signal xlclockdriver_1_clk: std_logic;

begin
  sysce_x0 <= sysce;
  sysce_clr_x0 <= sysce_clr;
  sysclk_x0 <= sysclk;
  plb_ce_1 <= xlclockdriver_1_ce;
  plb_clk_1 <= xlclockdriver_1_clk;

  xlclockdriver_1: entity work.xlclockdriver
    generic map (
      log_2_period => 1,
      period => 1,
      use_bufg => 0
    )
    port map (
      sysce => sysce_x0,
      sysclk => sysclk_x0,
      sysclr => sysce_clr_x0,
      ce => xlclockdriver_1_ce,
      clk => xlclockdriver_1_clk
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

entity w2_warplab_buffers_cw is
  port (
    agc_done: in std_logic; 
    ce: in std_logic := '1'; 
    clk: in std_logic; -- clock period = 10.0 ns (100.0 Mhz)
    fromagc_radio1_i: in std_logic_vector(13 downto 0); 
    fromagc_radio1_q: in std_logic_vector(13 downto 0); 
    fromagc_radio2_i: in std_logic_vector(13 downto 0); 
    fromagc_radio2_q: in std_logic_vector(13 downto 0); 
    fromagc_radio3_i: in std_logic_vector(13 downto 0); 
    fromagc_radio3_q: in std_logic_vector(13 downto 0); 
    fromagc_radio4_i: in std_logic_vector(13 downto 0); 
    fromagc_radio4_q: in std_logic_vector(13 downto 0); 
    plb_abus: in std_logic_vector(31 downto 0); 
    plb_pavalid: in std_logic; 
    plb_rnw: in std_logic; 
    plb_wrdbus: in std_logic_vector(31 downto 0); 
    radio1_adc_i: in std_logic_vector(13 downto 0); 
    radio1_adc_i_otr: in std_logic; 
    radio1_adc_q: in std_logic_vector(13 downto 0); 
    radio1_adc_q_otr: in std_logic; 
    radio1_rssi: in std_logic_vector(9 downto 0); 
    radio2_adc_i: in std_logic_vector(13 downto 0); 
    radio2_adc_i_otr: in std_logic; 
    radio2_adc_q: in std_logic_vector(13 downto 0); 
    radio2_adc_q_otr: in std_logic; 
    radio2_rssi: in std_logic_vector(9 downto 0); 
    radio3_adc_i: in std_logic_vector(13 downto 0); 
    radio3_adc_i_otr: in std_logic; 
    radio3_adc_q: in std_logic_vector(13 downto 0); 
    radio3_adc_q_otr: in std_logic; 
    radio3_rssi: in std_logic_vector(9 downto 0); 
    radio4_adc_i: in std_logic_vector(13 downto 0); 
    radio4_adc_i_otr: in std_logic; 
    radio4_adc_q: in std_logic_vector(13 downto 0); 
    radio4_adc_q_otr: in std_logic; 
    radio4_rssi: in std_logic_vector(9 downto 0); 
    sg_plb_addrpref: in std_logic_vector(9 downto 0); 
    splb_rst: in std_logic; 
    startcapture: in std_logic; 
    starttx: in std_logic; 
    stoptx: in std_logic; 
    xps_ce: in std_logic := '1'; 
    xps_clk: in std_logic; -- clock period = 10.0 ns (100.0 Mhz)
    debug_agc_done: out std_logic; 
    debug_capturing: out std_logic; 
    debug_transmitting: out std_logic; 
    radio1_dac_i: out std_logic_vector(15 downto 0); 
    radio1_dac_q: out std_logic_vector(15 downto 0); 
    radio2_dac_i: out std_logic_vector(15 downto 0); 
    radio2_dac_q: out std_logic_vector(15 downto 0); 
    radio3_dac_i: out std_logic_vector(15 downto 0); 
    radio3_dac_q: out std_logic_vector(15 downto 0); 
    radio4_dac_i: out std_logic_vector(15 downto 0); 
    radio4_dac_q: out std_logic_vector(15 downto 0); 
    rssi_adc_clk: out std_logic; 
    sl_addrack: out std_logic; 
    sl_rdcomp: out std_logic; 
    sl_rddack: out std_logic; 
    sl_rddbus: out std_logic_vector(31 downto 0); 
    sl_wait: out std_logic; 
    sl_wrcomp: out std_logic; 
    sl_wrdack: out std_logic
  );
end w2_warplab_buffers_cw;

architecture structural of w2_warplab_buffers_cw is
  component block_memory_generator_virtex4_6_3_336435e2d26b043e
    port (
      addra: in std_logic_vector(10 downto 0); 
      addrb: in std_logic_vector(10 downto 0); 
      clka: in std_logic; 
      clkb: in std_logic; 
      dina: in std_logic_vector(31 downto 0); 
      dinb: in std_logic_vector(31 downto 0); 
      ena: in std_logic; 
      enb: in std_logic; 
      wea: in std_logic_vector(0 downto 0); 
      web: in std_logic_vector(0 downto 0); 
      douta: out std_logic_vector(31 downto 0); 
      doutb: out std_logic_vector(31 downto 0)
    );
  end component;
  attribute syn_black_box: boolean;
  attribute syn_black_box of block_memory_generator_virtex4_6_3_336435e2d26b043e: component is true;
  attribute box_type: string;
  attribute box_type of block_memory_generator_virtex4_6_3_336435e2d26b043e: component is "black_box";
  attribute syn_noprune: boolean;
  attribute optimize_primitives: boolean;
  attribute dont_touch: boolean;
  attribute syn_noprune of block_memory_generator_virtex4_6_3_336435e2d26b043e: component is true;
  attribute optimize_primitives of block_memory_generator_virtex4_6_3_336435e2d26b043e: component is false;
  attribute dont_touch of block_memory_generator_virtex4_6_3_336435e2d26b043e: component is true;

  component block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port (
      addra: in std_logic_vector(13 downto 0); 
      addrb: in std_logic_vector(13 downto 0); 
      clka: in std_logic; 
      clkb: in std_logic; 
      dina: in std_logic_vector(31 downto 0); 
      dinb: in std_logic_vector(31 downto 0); 
      ena: in std_logic; 
      enb: in std_logic; 
      wea: in std_logic_vector(0 downto 0); 
      web: in std_logic_vector(0 downto 0); 
      douta: out std_logic_vector(31 downto 0); 
      doutb: out std_logic_vector(31 downto 0)
    );
  end component;
  attribute syn_black_box of block_memory_generator_virtex4_6_3_7cb72653cb2c8625: component is true;
  attribute box_type of block_memory_generator_virtex4_6_3_7cb72653cb2c8625: component is "black_box";
  attribute syn_noprune of block_memory_generator_virtex4_6_3_7cb72653cb2c8625: component is true;
  attribute optimize_primitives of block_memory_generator_virtex4_6_3_7cb72653cb2c8625: component is false;
  attribute dont_touch of block_memory_generator_virtex4_6_3_7cb72653cb2c8625: component is true;

  component xlpersistentdff
    port (
      clk: in std_logic; 
      d: in std_logic; 
      q: out std_logic
    );
  end component;
  attribute syn_black_box of xlpersistentdff: component is true;
  attribute box_type of xlpersistentdff: component is "black_box";
  attribute syn_noprune of xlpersistentdff: component is true;
  attribute optimize_primitives of xlpersistentdff: component is false;
  attribute dont_touch of xlpersistentdff: component is true;

  signal AGCDoneAddr_reg_ce: std_logic;
  signal CaptureDone_reg_ce: std_logic;
  signal DCO_EN_SEL_reg_ce: std_logic;
  signal DebugRx1Buffers_reg_ce: std_logic;
  signal DebugRx2Buffers_reg_ce: std_logic;
  signal DebugRx3Buffers_reg_ce: std_logic;
  signal DebugRx4Buffers_reg_ce: std_logic;
  signal MGC_AGC_SEL_reg_ce: std_logic;
  signal RADIO1RXBUFF_RXEN_reg_ce: std_logic;
  signal RADIO1TXBUFF_TXEN_reg_ce: std_logic;
  signal RADIO2RXBUFF_RXEN_reg_ce: std_logic;
  signal RADIO2TXBUFF_TXEN_reg_ce: std_logic;
  signal RADIO3RXBUFF_RXEN_reg_ce: std_logic;
  signal RADIO3TXBUFF_TXEN_reg_ce: std_logic;
  signal RADIO4RXBUFF_RXEN_reg_ce: std_logic;
  signal RADIO4TXBUFF_TXEN_reg_ce: std_logic;
  signal Radio1AGCDoneRSSI_reg_ce: std_logic;
  signal Radio2AGCDoneRSSI_reg_ce: std_logic;
  signal Radio3AGCDoneRSSI_reg_ce: std_logic;
  signal Radio4AGCDoneRSSI_reg_ce: std_logic;
  signal StartCapture_reg_ce: std_logic;
  signal StartTxRx_reg_ce: std_logic;
  signal StartTx_reg_ce: std_logic;
  signal StopTx_reg_ce: std_logic;
  signal TransMode_reg_ce: std_logic;
  signal TxDelay_reg_ce: std_logic;
  signal TxLength_reg_ce: std_logic;
  signal addr_net: std_logic_vector(13 downto 0);
  signal addr_x0_net: std_logic_vector(13 downto 0);
  signal addr_x10_net: std_logic_vector(10 downto 0);
  signal addr_x11_net: std_logic_vector(10 downto 0);
  signal addr_x14_net: std_logic_vector(10 downto 0);
  signal addr_x17_net: std_logic_vector(10 downto 0);
  signal addr_x1_net: std_logic_vector(10 downto 0);
  signal addr_x20_net: std_logic_vector(10 downto 0);
  signal addr_x2_net: std_logic_vector(10 downto 0);
  signal addr_x3_net: std_logic_vector(13 downto 0);
  signal addr_x4_net: std_logic_vector(13 downto 0);
  signal addr_x5_net: std_logic_vector(13 downto 0);
  signal addr_x6_net: std_logic_vector(13 downto 0);
  signal addr_x7_net: std_logic_vector(13 downto 0);
  signal addr_x8_net: std_logic_vector(13 downto 0);
  signal addr_x9_net: std_logic_vector(10 downto 0);
  signal agc_done_net_x0: std_logic;
  signal agc_done_net_x1: std_logic;
  signal ce_1_sg_x50: std_logic;
  attribute MAX_FANOUT: string;
  attribute MAX_FANOUT of ce_1_sg_x50: signal is "REDUCE";
  signal ce_2_sg_x0: std_logic;
  attribute MAX_FANOUT of ce_2_sg_x0: signal is "REDUCE";
  signal clkNet: std_logic;
  signal clkNet_x0: std_logic;
  signal clk_1_sg_x50: std_logic;
  signal clk_2_sg_x0: std_logic;
  signal convert2_dout_net_x0: std_logic;
  signal convert2_dout_net_x1: std_logic;
  signal convert2_dout_net_x2: std_logic;
  signal convert2_dout_net_x3: std_logic;
  signal convert2_dout_net_x4: std_logic;
  signal data_in_net: std_logic_vector(31 downto 0);
  signal data_in_x0_net: std_logic_vector(31 downto 0);
  signal data_in_x10_net: std_logic_vector(31 downto 0);
  signal data_in_x11_net: std_logic;
  signal data_in_x12_net: std_logic;
  signal data_in_x13_net: std_logic;
  signal data_in_x14_net: std_logic;
  signal data_in_x15_net: std_logic;
  signal data_in_x16_net: std_logic;
  signal data_in_x17_net: std_logic;
  signal data_in_x18_net: std_logic;
  signal data_in_x19_net: std_logic;
  signal data_in_x1_net: std_logic_vector(31 downto 0);
  signal data_in_x20_net: std_logic;
  signal data_in_x21_net: std_logic_vector(13 downto 0);
  signal data_in_x22_net: std_logic_vector(13 downto 0);
  signal data_in_x23_net: std_logic;
  signal data_in_x24_net: std_logic;
  signal data_in_x25_net: std_logic;
  signal data_in_x26_net: std_logic;
  signal data_in_x27_net: std_logic;
  signal data_in_x28_net: std_logic;
  signal data_in_x29_net: std_logic;
  signal data_in_x2_net: std_logic_vector(31 downto 0);
  signal data_in_x30_net: std_logic;
  signal data_in_x31_net: std_logic;
  signal data_in_x33_net: std_logic_vector(9 downto 0);
  signal data_in_x34_net: std_logic_vector(9 downto 0);
  signal data_in_x35_net: std_logic_vector(9 downto 0);
  signal data_in_x36_net: std_logic_vector(9 downto 0);
  signal data_in_x37_net: std_logic;
  signal data_in_x38_net: std_logic_vector(31 downto 0);
  signal data_in_x39_net: std_logic_vector(31 downto 0);
  signal data_in_x3_net: std_logic_vector(31 downto 0);
  signal data_in_x40_net: std_logic_vector(31 downto 0);
  signal data_in_x41_net: std_logic_vector(31 downto 0);
  signal data_in_x42_net: std_logic_vector(31 downto 0);
  signal data_in_x43_net: std_logic_vector(31 downto 0);
  signal data_in_x44_net: std_logic_vector(31 downto 0);
  signal data_in_x45_net: std_logic_vector(31 downto 0);
  signal data_in_x46_net: std_logic_vector(31 downto 0);
  signal data_in_x47_net: std_logic_vector(31 downto 0);
  signal data_in_x48_net: std_logic_vector(31 downto 0);
  signal data_in_x49_net: std_logic_vector(31 downto 0);
  signal data_in_x4_net: std_logic_vector(31 downto 0);
  signal data_in_x5_net: std_logic_vector(31 downto 0);
  signal data_in_x6_net: std_logic_vector(31 downto 0);
  signal data_in_x7_net: std_logic_vector(31 downto 0);
  signal data_in_x8_net: std_logic_vector(31 downto 0);
  signal data_in_x9_net: std_logic_vector(31 downto 0);
  signal data_out_net: std_logic_vector(13 downto 0);
  signal data_out_x0_net: std_logic;
  signal data_out_x10_net: std_logic_vector(31 downto 0);
  signal data_out_x11_net: std_logic_vector(31 downto 0);
  signal data_out_x12_net: std_logic_vector(31 downto 0);
  signal data_out_x13_net: std_logic_vector(31 downto 0);
  signal data_out_x14_net: std_logic_vector(31 downto 0);
  signal data_out_x15_net: std_logic_vector(31 downto 0);
  signal data_out_x16_net: std_logic_vector(31 downto 0);
  signal data_out_x17_net: std_logic;
  signal data_out_x18_net: std_logic;
  signal data_out_x19_net: std_logic;
  signal data_out_x1_net: std_logic_vector(9 downto 0);
  signal data_out_x20_net: std_logic;
  signal data_out_x21_net: std_logic;
  signal data_out_x22_net: std_logic;
  signal data_out_x23_net: std_logic;
  signal data_out_x24_net: std_logic;
  signal data_out_x25_net: std_logic;
  signal data_out_x26_net: std_logic;
  signal data_out_x27_net: std_logic;
  signal data_out_x28_net: std_logic;
  signal data_out_x29_net: std_logic;
  signal data_out_x2_net: std_logic_vector(9 downto 0);
  signal data_out_x30_net: std_logic;
  signal data_out_x31_net: std_logic;
  signal data_out_x32_net: std_logic;
  signal data_out_x33_net: std_logic;
  signal data_out_x34_net: std_logic;
  signal data_out_x35_net: std_logic;
  signal data_out_x36_net: std_logic_vector(13 downto 0);
  signal data_out_x39_net: std_logic_vector(31 downto 0);
  signal data_out_x3_net: std_logic_vector(9 downto 0);
  signal data_out_x42_net: std_logic_vector(31 downto 0);
  signal data_out_x45_net: std_logic_vector(31 downto 0);
  signal data_out_x48_net: std_logic_vector(31 downto 0);
  signal data_out_x49_net: std_logic_vector(13 downto 0);
  signal data_out_x4_net: std_logic_vector(9 downto 0);
  signal data_out_x5_net: std_logic_vector(31 downto 0);
  signal data_out_x6_net: std_logic_vector(31 downto 0);
  signal data_out_x7_net: std_logic_vector(31 downto 0);
  signal data_out_x8_net: std_logic_vector(31 downto 0);
  signal data_out_x9_net: std_logic_vector(31 downto 0);
  signal debug_capturing_net: std_logic;
  signal debug_transmitting_net: std_logic;
  signal en_net: std_logic;
  signal en_x0_net: std_logic;
  signal en_x10_net: std_logic;
  signal en_x11_net: std_logic;
  signal en_x12_net: std_logic;
  signal en_x13_net: std_logic;
  signal en_x14_net: std_logic;
  signal en_x15_net: std_logic;
  signal en_x16_net: std_logic;
  signal en_x17_net: std_logic;
  signal en_x18_net: std_logic;
  signal en_x19_net: std_logic;
  signal en_x1_net: std_logic;
  signal en_x25_net: std_logic;
  signal en_x2_net: std_logic;
  signal en_x3_net: std_logic;
  signal en_x4_net: std_logic;
  signal en_x5_net: std_logic;
  signal en_x6_net: std_logic;
  signal en_x7_net: std_logic;
  signal en_x8_net: std_logic;
  signal en_x9_net: std_logic;
  signal fromagc_radio1_i_net: std_logic_vector(13 downto 0);
  signal fromagc_radio1_q_net: std_logic_vector(13 downto 0);
  signal fromagc_radio2_i_net: std_logic_vector(13 downto 0);
  signal fromagc_radio2_q_net: std_logic_vector(13 downto 0);
  signal fromagc_radio3_i_net: std_logic_vector(13 downto 0);
  signal fromagc_radio3_q_net: std_logic_vector(13 downto 0);
  signal fromagc_radio4_i_net: std_logic_vector(13 downto 0);
  signal fromagc_radio4_q_net: std_logic_vector(13 downto 0);
  signal logical_y_net_x10: std_logic;
  signal logical_y_net_x11: std_logic;
  signal logical_y_net_x12: std_logic;
  signal logical_y_net_x13: std_logic;
  signal logical_y_net_x14: std_logic;
  signal logical_y_net_x15: std_logic;
  signal logical_y_net_x16: std_logic;
  signal logical_y_net_x17: std_logic;
  signal persistentdff_inst_q: std_logic;
  attribute syn_keep: boolean;
  attribute syn_keep of persistentdff_inst_q: signal is true;
  attribute keep: boolean;
  attribute keep of persistentdff_inst_q: signal is true;
  attribute preserve_signal: boolean;
  attribute preserve_signal of persistentdff_inst_q: signal is true;
  signal plb_abus_net: std_logic_vector(31 downto 0);
  signal plb_ce_1_sg_x1: std_logic;
  attribute MAX_FANOUT of plb_ce_1_sg_x1: signal is "REDUCE";
  signal plb_clk_1_sg_x1: std_logic;
  signal plb_pavalid_net: std_logic;
  signal plb_rnw_net: std_logic;
  signal plb_wrdbus_net: std_logic_vector(31 downto 0);
  signal radio1_adc_i_net: std_logic_vector(13 downto 0);
  signal radio1_adc_i_otr_net: std_logic;
  signal radio1_adc_q_net: std_logic_vector(13 downto 0);
  signal radio1_adc_q_otr_net: std_logic;
  signal radio1_dac_i_net: std_logic_vector(15 downto 0);
  signal radio1_dac_q_net: std_logic_vector(15 downto 0);
  signal radio1_rssi_net: std_logic_vector(9 downto 0);
  signal radio2_adc_i_net: std_logic_vector(13 downto 0);
  signal radio2_adc_i_otr_net: std_logic;
  signal radio2_adc_q_net: std_logic_vector(13 downto 0);
  signal radio2_adc_q_otr_net: std_logic;
  signal radio2_dac_i_net: std_logic_vector(15 downto 0);
  signal radio2_dac_q_net: std_logic_vector(15 downto 0);
  signal radio2_rssi_net: std_logic_vector(9 downto 0);
  signal radio3_adc_i_net: std_logic_vector(13 downto 0);
  signal radio3_adc_i_otr_net: std_logic;
  signal radio3_adc_q_net: std_logic_vector(13 downto 0);
  signal radio3_adc_q_otr_net: std_logic;
  signal radio3_dac_i_net: std_logic_vector(15 downto 0);
  signal radio3_dac_q_net: std_logic_vector(15 downto 0);
  signal radio3_rssi_net: std_logic_vector(9 downto 0);
  signal radio4_adc_i_net: std_logic_vector(13 downto 0);
  signal radio4_adc_i_otr_net: std_logic;
  signal radio4_adc_q_net: std_logic_vector(13 downto 0);
  signal radio4_adc_q_otr_net: std_logic;
  signal radio4_dac_i_net: std_logic_vector(15 downto 0);
  signal radio4_dac_q_net: std_logic_vector(15 downto 0);
  signal radio4_rssi_net: std_logic_vector(9 downto 0);
  signal rssi_adc_clk_net: std_logic;
  signal rx_addr_counter1_op_net_x10: std_logic_vector(13 downto 0);
  signal rx_addr_counter1_op_net_x11: std_logic_vector(13 downto 0);
  signal rx_addr_counter1_op_net_x12: std_logic_vector(13 downto 0);
  signal rx_addr_counter1_op_net_x13: std_logic_vector(13 downto 0);
  signal rx_addr_counter1_op_net_x9: std_logic_vector(13 downto 0);
  signal sg_plb_addrpref_net: std_logic_vector(9 downto 0);
  signal shared_memory_data_out_net: std_logic_vector(31 downto 0);
  signal shared_memory_data_out_net_x0: std_logic_vector(31 downto 0);
  signal shared_memory_data_out_net_x1: std_logic_vector(31 downto 0);
  signal shared_memory_data_out_net_x2: std_logic_vector(31 downto 0);
  signal shared_memory_data_out_net_x3: std_logic_vector(31 downto 0);
  signal shared_memory_data_out_net_x4: std_logic_vector(31 downto 0);
  signal shared_memory_data_out_net_x5: std_logic_vector(31 downto 0);
  signal shared_memory_data_out_net_x6: std_logic_vector(31 downto 0);
  signal sl_addrack_net: std_logic;
  signal sl_rdcomp_net: std_logic;
  signal sl_rddack_net: std_logic;
  signal sl_rddbus_net: std_logic_vector(31 downto 0);
  signal sl_wait_net: std_logic;
  signal sl_wrdack_x1: std_logic;
  signal sl_wrdack_x2: std_logic;
  signal splb_rst_net: std_logic;
  signal startcapture_net: std_logic;
  signal starttx_net: std_logic;
  signal stoptx_net: std_logic;
  signal tx_addr_counter_op_net_x1: std_logic_vector(13 downto 0);
  signal tx_addr_counter_op_net_x2: std_logic_vector(13 downto 0);
  signal tx_addr_counter_op_net_x3: std_logic_vector(13 downto 0);
  signal tx_addr_counter_op_net_x4: std_logic_vector(13 downto 0);
  signal we_net: std_logic;
  signal we_x0_net: std_logic;
  signal we_x10_net: std_logic;
  signal we_x13_net: std_logic;
  signal we_x16_net: std_logic;
  signal we_x19_net: std_logic;
  signal we_x1_net: std_logic;
  signal we_x22_net: std_logic;
  signal we_x2_net: std_logic;
  signal we_x3_net: std_logic;
  signal we_x4_net: std_logic;
  signal we_x5_net: std_logic;
  signal we_x6_net: std_logic;
  signal we_x7_net: std_logic;
  signal we_x8_net: std_logic;
  signal we_x9_net: std_logic;

begin
  agc_done_net_x0 <= agc_done;
  clkNet <= clk;
  fromagc_radio1_i_net <= fromagc_radio1_i;
  fromagc_radio1_q_net <= fromagc_radio1_q;
  fromagc_radio2_i_net <= fromagc_radio2_i;
  fromagc_radio2_q_net <= fromagc_radio2_q;
  fromagc_radio3_i_net <= fromagc_radio3_i;
  fromagc_radio3_q_net <= fromagc_radio3_q;
  fromagc_radio4_i_net <= fromagc_radio4_i;
  fromagc_radio4_q_net <= fromagc_radio4_q;
  plb_abus_net <= plb_abus;
  plb_pavalid_net <= plb_pavalid;
  plb_rnw_net <= plb_rnw;
  plb_wrdbus_net <= plb_wrdbus;
  radio1_adc_i_net <= radio1_adc_i;
  radio1_adc_i_otr_net <= radio1_adc_i_otr;
  radio1_adc_q_net <= radio1_adc_q;
  radio1_adc_q_otr_net <= radio1_adc_q_otr;
  radio1_rssi_net <= radio1_rssi;
  radio2_adc_i_net <= radio2_adc_i;
  radio2_adc_i_otr_net <= radio2_adc_i_otr;
  radio2_adc_q_net <= radio2_adc_q;
  radio2_adc_q_otr_net <= radio2_adc_q_otr;
  radio2_rssi_net <= radio2_rssi;
  radio3_adc_i_net <= radio3_adc_i;
  radio3_adc_i_otr_net <= radio3_adc_i_otr;
  radio3_adc_q_net <= radio3_adc_q;
  radio3_adc_q_otr_net <= radio3_adc_q_otr;
  radio3_rssi_net <= radio3_rssi;
  radio4_adc_i_net <= radio4_adc_i;
  radio4_adc_i_otr_net <= radio4_adc_i_otr;
  radio4_adc_q_net <= radio4_adc_q;
  radio4_adc_q_otr_net <= radio4_adc_q_otr;
  radio4_rssi_net <= radio4_rssi;
  sg_plb_addrpref_net <= sg_plb_addrpref;
  splb_rst_net <= splb_rst;
  startcapture_net <= startcapture;
  starttx_net <= starttx;
  stoptx_net <= stoptx;
  clkNet_x0 <= xps_clk;
  debug_agc_done <= agc_done_net_x1;
  debug_capturing <= debug_capturing_net;
  debug_transmitting <= debug_transmitting_net;
  radio1_dac_i <= radio1_dac_i_net;
  radio1_dac_q <= radio1_dac_q_net;
  radio2_dac_i <= radio2_dac_i_net;
  radio2_dac_q <= radio2_dac_q_net;
  radio3_dac_i <= radio3_dac_i_net;
  radio3_dac_q <= radio3_dac_q_net;
  radio4_dac_i <= radio4_dac_i_net;
  radio4_dac_q <= radio4_dac_q_net;
  rssi_adc_clk <= rssi_adc_clk_net;
  sl_addrack <= sl_addrack_net;
  sl_rdcomp <= sl_rdcomp_net;
  sl_rddack <= sl_rddack_net;
  sl_rddbus <= sl_rddbus_net;
  sl_wait <= sl_wait_net;
  sl_wrcomp <= sl_wrdack_x1;
  sl_wrdack <= sl_wrdack_x2;

  AGCDoneAddr: entity work.synth_reg_w_init
    generic map (
      width => 14,
      init_index => 2,
      init_value => b"00000000000000",
      latency => 1
    )
    port map (
      ce => AGCDoneAddr_reg_ce,
      clk => clk_1_sg_x50,
      clr => '0',
      i => rx_addr_counter1_op_net_x9,
      o => data_out_net
    );

  AGCDoneAddr_ce_and2_comp: entity work.xland2
    port map (
      a => ce_1_sg_x50,
      b => convert2_dout_net_x0,
      dout => AGCDoneAddr_reg_ce
    );

  CaptureDone: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => CaptureDone_reg_ce,
      clk => clk_1_sg_x50,
      clr => '0',
      i(0) => data_in_x37_net,
      o(0) => data_out_x0_net
    );

  CaptureDone_ce_and2_comp: entity work.xland2
    port map (
      a => ce_1_sg_x50,
      b => en_x25_net,
      dout => CaptureDone_reg_ce
    );

  DCO_EN_SEL: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"1",
      latency => 1
    )
    port map (
      ce => DCO_EN_SEL_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x11_net,
      o(0) => data_out_x26_net
    );

  DCO_EN_SEL_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_net,
      dout => DCO_EN_SEL_reg_ce
    );

  DebugRx1Buffers: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => DebugRx1Buffers_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x12_net,
      o(0) => data_out_x17_net
    );

  DebugRx1Buffers_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x0_net,
      dout => DebugRx1Buffers_reg_ce
    );

  DebugRx2Buffers: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => DebugRx2Buffers_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x23_net,
      o(0) => data_out_x18_net
    );

  DebugRx2Buffers_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x11_net,
      dout => DebugRx2Buffers_reg_ce
    );

  DebugRx3Buffers: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => DebugRx3Buffers_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x25_net,
      o(0) => data_out_x19_net
    );

  DebugRx3Buffers_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x13_net,
      dout => DebugRx3Buffers_reg_ce
    );

  DebugRx4Buffers: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => DebugRx4Buffers_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x26_net,
      o(0) => data_out_x20_net
    );

  DebugRx4Buffers_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x14_net,
      dout => DebugRx4Buffers_reg_ce
    );

  MGC_AGC_SEL: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"1",
      latency => 1
    )
    port map (
      ce => MGC_AGC_SEL_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x27_net,
      o(0) => data_out_x25_net
    );

  MGC_AGC_SEL_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x15_net,
      dout => MGC_AGC_SEL_reg_ce
    );

  RADIO1RXBUFF_RXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO1RXBUFF_RXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x28_net,
      o(0) => data_out_x21_net
    );

  RADIO1RXBUFF_RXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x16_net,
      dout => RADIO1RXBUFF_RXEN_reg_ce
    );

  RADIO1TXBUFF_TXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO1TXBUFF_TXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x29_net,
      o(0) => data_out_x32_net
    );

  RADIO1TXBUFF_TXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x17_net,
      dout => RADIO1TXBUFF_TXEN_reg_ce
    );

  RADIO2RXBUFF_RXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO2RXBUFF_RXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x30_net,
      o(0) => data_out_x31_net
    );

  RADIO2RXBUFF_RXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x18_net,
      dout => RADIO2RXBUFF_RXEN_reg_ce
    );

  RADIO2TXBUFF_TXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO2TXBUFF_TXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x31_net,
      o(0) => data_out_x35_net
    );

  RADIO2TXBUFF_TXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x19_net,
      dout => RADIO2TXBUFF_TXEN_reg_ce
    );

  RADIO3RXBUFF_RXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO3RXBUFF_RXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x13_net,
      o(0) => data_out_x23_net
    );

  RADIO3RXBUFF_RXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x1_net,
      dout => RADIO3RXBUFF_RXEN_reg_ce
    );

  RADIO3TXBUFF_TXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO3TXBUFF_TXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x14_net,
      o(0) => data_out_x22_net
    );

  RADIO3TXBUFF_TXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x2_net,
      dout => RADIO3TXBUFF_TXEN_reg_ce
    );

  RADIO4RXBUFF_RXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO4RXBUFF_RXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x15_net,
      o(0) => data_out_x29_net
    );

  RADIO4RXBUFF_RXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x3_net,
      dout => RADIO4RXBUFF_RXEN_reg_ce
    );

  RADIO4TXBUFF_TXEN: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => RADIO4TXBUFF_TXEN_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x16_net,
      o(0) => data_out_x24_net
    );

  RADIO4TXBUFF_TXEN_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x4_net,
      dout => RADIO4TXBUFF_TXEN_reg_ce
    );

  RSSIBuff_Radio1: block_memory_generator_virtex4_6_3_336435e2d26b043e
    port map (
      addra => addr_x11_net,
      addrb => addr_x9_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x38_net,
      dinb => data_in_x9_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x10,
      web(0) => we_x9_net,
      douta => shared_memory_data_out_net,
      doutb => data_out_x15_net
    );

  RSSIBuff_Radio2: block_memory_generator_virtex4_6_3_336435e2d26b043e
    port map (
      addra => addr_x14_net,
      addrb => addr_x10_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x41_net,
      dinb => data_in_x10_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x12,
      web(0) => we_x10_net,
      douta => shared_memory_data_out_net_x1,
      doutb => data_out_x16_net
    );

  RSSIBuff_Radio3: block_memory_generator_virtex4_6_3_336435e2d26b043e
    port map (
      addra => addr_x17_net,
      addrb => addr_x1_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x44_net,
      dinb => data_in_x1_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x14,
      web(0) => we_x1_net,
      douta => shared_memory_data_out_net_x3,
      doutb => data_out_x7_net
    );

  RSSIBuff_Radio4: block_memory_generator_virtex4_6_3_336435e2d26b043e
    port map (
      addra => addr_x20_net,
      addrb => addr_x2_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x47_net,
      dinb => data_in_x2_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x16,
      web(0) => we_x2_net,
      douta => shared_memory_data_out_net_x5,
      doutb => data_out_x8_net
    );

  Radio1AGCDoneRSSI: entity work.synth_reg_w_init
    generic map (
      width => 10,
      init_index => 2,
      init_value => b"0000000000",
      latency => 1
    )
    port map (
      ce => Radio1AGCDoneRSSI_reg_ce,
      clk => clk_1_sg_x50,
      clr => '0',
      i => data_in_x33_net,
      o => data_out_x1_net
    );

  Radio1AGCDoneRSSI_ce_and2_comp: entity work.xland2
    port map (
      a => ce_1_sg_x50,
      b => convert2_dout_net_x1,
      dout => Radio1AGCDoneRSSI_reg_ce
    );

  Radio2AGCDoneRSSI: entity work.synth_reg_w_init
    generic map (
      width => 10,
      init_index => 2,
      init_value => b"0000000000",
      latency => 1
    )
    port map (
      ce => Radio2AGCDoneRSSI_reg_ce,
      clk => clk_1_sg_x50,
      clr => '0',
      i => data_in_x34_net,
      o => data_out_x2_net
    );

  Radio2AGCDoneRSSI_ce_and2_comp: entity work.xland2
    port map (
      a => ce_1_sg_x50,
      b => convert2_dout_net_x2,
      dout => Radio2AGCDoneRSSI_reg_ce
    );

  Radio3AGCDoneRSSI: entity work.synth_reg_w_init
    generic map (
      width => 10,
      init_index => 2,
      init_value => b"0000000000",
      latency => 1
    )
    port map (
      ce => Radio3AGCDoneRSSI_reg_ce,
      clk => clk_1_sg_x50,
      clr => '0',
      i => data_in_x35_net,
      o => data_out_x3_net
    );

  Radio3AGCDoneRSSI_ce_and2_comp: entity work.xland2
    port map (
      a => ce_1_sg_x50,
      b => convert2_dout_net_x3,
      dout => Radio3AGCDoneRSSI_reg_ce
    );

  Radio4AGCDoneRSSI: entity work.synth_reg_w_init
    generic map (
      width => 10,
      init_index => 2,
      init_value => b"0000000000",
      latency => 1
    )
    port map (
      ce => Radio4AGCDoneRSSI_reg_ce,
      clk => clk_1_sg_x50,
      clr => '0',
      i => data_in_x36_net,
      o => data_out_x4_net
    );

  Radio4AGCDoneRSSI_ce_and2_comp: entity work.xland2
    port map (
      a => ce_1_sg_x50,
      b => convert2_dout_net_x4,
      dout => Radio4AGCDoneRSSI_reg_ce
    );

  RxBuff_Radio1: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => rx_addr_counter1_op_net_x10,
      addrb => addr_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x39_net,
      dinb => data_in_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x11,
      web(0) => we_net,
      douta => shared_memory_data_out_net_x0,
      doutb => data_out_x5_net
    );

  RxBuff_Radio2: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => rx_addr_counter1_op_net_x11,
      addrb => addr_x0_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x42_net,
      dinb => data_in_x0_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x13,
      web(0) => we_x0_net,
      douta => shared_memory_data_out_net_x2,
      doutb => data_out_x6_net
    );

  RxBuff_Radio3: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => rx_addr_counter1_op_net_x12,
      addrb => addr_x3_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x45_net,
      dinb => data_in_x3_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x15,
      web(0) => we_x3_net,
      douta => shared_memory_data_out_net_x4,
      doutb => data_out_x9_net
    );

  RxBuff_Radio4: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => rx_addr_counter1_op_net_x13,
      addrb => addr_x4_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x48_net,
      dinb => data_in_x4_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => logical_y_net_x17,
      web(0) => we_x4_net,
      douta => shared_memory_data_out_net_x6,
      doutb => data_out_x10_net
    );

  StartCapture_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x5_net,
      dout => StartCapture_reg_ce
    );

  StartCapture_x0: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => StartCapture_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x17_net,
      o(0) => data_out_x28_net
    );

  StartTxRx: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => StartTxRx_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x24_net,
      o(0) => data_out_x27_net
    );

  StartTxRx_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x12_net,
      dout => StartTxRx_reg_ce
    );

  StartTx_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x6_net,
      dout => StartTx_reg_ce
    );

  StartTx_x0: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => StartTx_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x18_net,
      o(0) => data_out_x30_net
    );

  StopTx_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x7_net,
      dout => StopTx_reg_ce
    );

  StopTx_x0: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => StopTx_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x19_net,
      o(0) => data_out_x33_net
    );

  TransMode: entity work.synth_reg_w_init
    generic map (
      width => 1,
      init_index => 2,
      init_value => b"0",
      latency => 1
    )
    port map (
      ce => TransMode_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i(0) => data_in_x20_net,
      o(0) => data_out_x34_net
    );

  TransMode_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x8_net,
      dout => TransMode_reg_ce
    );

  TxBuff_Radio1: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => tx_addr_counter_op_net_x2,
      addrb => addr_x5_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x40_net,
      dinb => data_in_x5_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => we_x13_net,
      web(0) => we_x5_net,
      douta => data_out_x39_net,
      doutb => data_out_x11_net
    );

  TxBuff_Radio2: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => tx_addr_counter_op_net_x3,
      addrb => addr_x6_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x43_net,
      dinb => data_in_x6_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => we_x16_net,
      web(0) => we_x6_net,
      douta => data_out_x42_net,
      doutb => data_out_x12_net
    );

  TxBuff_Radio3: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => tx_addr_counter_op_net_x4,
      addrb => addr_x7_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x46_net,
      dinb => data_in_x7_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => we_x19_net,
      web(0) => we_x7_net,
      douta => data_out_x45_net,
      doutb => data_out_x13_net
    );

  TxBuff_Radio4: block_memory_generator_virtex4_6_3_7cb72653cb2c8625
    port map (
      addra => tx_addr_counter_op_net_x1,
      addrb => addr_x8_net,
      clka => clk_1_sg_x50,
      clkb => plb_clk_1_sg_x1,
      dina => data_in_x49_net,
      dinb => data_in_x8_net,
      ena => ce_1_sg_x50,
      enb => plb_ce_1_sg_x1,
      wea(0) => we_x22_net,
      web(0) => we_x8_net,
      douta => data_out_x48_net,
      doutb => data_out_x14_net
    );

  TxDelay: entity work.synth_reg_w_init
    generic map (
      width => 14,
      init_index => 2,
      init_value => b"00001111101000",
      latency => 1
    )
    port map (
      ce => TxDelay_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i => data_in_x21_net,
      o => data_out_x36_net
    );

  TxDelay_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x9_net,
      dout => TxDelay_reg_ce
    );

  TxLength: entity work.synth_reg_w_init
    generic map (
      width => 14,
      init_index => 2,
      init_value => b"11111111111111",
      latency => 1
    )
    port map (
      ce => TxLength_reg_ce,
      clk => plb_clk_1_sg_x1,
      clr => '0',
      i => data_in_x22_net,
      o => data_out_x49_net
    );

  TxLength_ce_and2_comp: entity work.xland2
    port map (
      a => plb_ce_1_sg_x1,
      b => en_x10_net,
      dout => TxLength_reg_ce
    );

  default_clock_driver_x0: entity work.default_clock_driver
    port map (
      sysce => '1',
      sysce_clr => '0',
      sysclk => clkNet,
      ce_1 => ce_1_sg_x50,
      ce_2 => ce_2_sg_x0,
      clk_1 => clk_1_sg_x50,
      clk_2 => clk_2_sg_x0
    );

  persistentdff_inst: xlpersistentdff
    port map (
      clk => clkNet,
      d => persistentdff_inst_q,
      q => persistentdff_inst_q
    );

  plb_clock_driver_x0: entity work.plb_clock_driver
    port map (
      sysce => '1',
      sysce_clr => '0',
      sysclk => clkNet_x0,
      plb_ce_1 => plb_ce_1_sg_x1,
      plb_clk_1 => plb_clk_1_sg_x1
    );

  w2_warplab_buffers_x0: entity work.w2_warplab_buffers
    port map (
      agc_done => agc_done_net_x0,
      ce_1 => ce_1_sg_x50,
      ce_2 => ce_2_sg_x0,
      clk_1 => clk_1_sg_x50,
      clk_2 => clk_2_sg_x0,
      data_out => data_out_net,
      data_out_x0 => data_out_x0_net,
      data_out_x1 => data_out_x1_net,
      data_out_x10 => data_out_x10_net,
      data_out_x11 => data_out_x11_net,
      data_out_x12 => data_out_x12_net,
      data_out_x13 => data_out_x13_net,
      data_out_x14 => data_out_x14_net,
      data_out_x15 => data_out_x15_net,
      data_out_x16 => data_out_x16_net,
      data_out_x17 => data_out_x17_net,
      data_out_x18 => data_out_x18_net,
      data_out_x19 => data_out_x19_net,
      data_out_x2 => data_out_x2_net,
      data_out_x20 => data_out_x20_net,
      data_out_x21 => data_out_x21_net,
      data_out_x22 => data_out_x22_net,
      data_out_x23 => data_out_x23_net,
      data_out_x24 => data_out_x24_net,
      data_out_x25 => data_out_x25_net,
      data_out_x26 => data_out_x26_net,
      data_out_x27 => data_out_x27_net,
      data_out_x28 => data_out_x28_net,
      data_out_x29 => data_out_x29_net,
      data_out_x3 => data_out_x3_net,
      data_out_x30 => data_out_x30_net,
      data_out_x31 => data_out_x31_net,
      data_out_x32 => data_out_x32_net,
      data_out_x33 => data_out_x33_net,
      data_out_x34 => data_out_x34_net,
      data_out_x35 => data_out_x35_net,
      data_out_x36 => data_out_x36_net,
      data_out_x39 => data_out_x39_net,
      data_out_x4 => data_out_x4_net,
      data_out_x42 => data_out_x42_net,
      data_out_x45 => data_out_x45_net,
      data_out_x48 => data_out_x48_net,
      data_out_x49 => data_out_x49_net,
      data_out_x5 => data_out_x5_net,
      data_out_x6 => data_out_x6_net,
      data_out_x7 => data_out_x7_net,
      data_out_x8 => data_out_x8_net,
      data_out_x9 => data_out_x9_net,
      dout => data_out_x26_net,
      dout_x0 => data_out_x17_net,
      dout_x1 => data_out_x23_net,
      dout_x10 => data_out_x49_net,
      dout_x11 => data_out_x18_net,
      dout_x12 => data_out_x27_net,
      dout_x13 => data_out_x19_net,
      dout_x14 => data_out_x20_net,
      dout_x15 => data_out_x25_net,
      dout_x16 => data_out_x21_net,
      dout_x17 => data_out_x32_net,
      dout_x18 => data_out_x31_net,
      dout_x19 => data_out_x35_net,
      dout_x2 => data_out_x22_net,
      dout_x3 => data_out_x29_net,
      dout_x4 => data_out_x24_net,
      dout_x5 => data_out_x28_net,
      dout_x6 => data_out_x30_net,
      dout_x7 => data_out_x33_net,
      dout_x8 => data_out_x34_net,
      dout_x9 => data_out_x36_net,
      fromagc_radio1_i => fromagc_radio1_i_net,
      fromagc_radio1_q => fromagc_radio1_q_net,
      fromagc_radio2_i => fromagc_radio2_i_net,
      fromagc_radio2_q => fromagc_radio2_q_net,
      fromagc_radio3_i => fromagc_radio3_i_net,
      fromagc_radio3_q => fromagc_radio3_q_net,
      fromagc_radio4_i => fromagc_radio4_i_net,
      fromagc_radio4_q => fromagc_radio4_q_net,
      plb_abus => plb_abus_net,
      plb_ce_1 => plb_ce_1_sg_x1,
      plb_clk_1 => plb_clk_1_sg_x1,
      plb_pavalid => plb_pavalid_net,
      plb_rnw => plb_rnw_net,
      plb_wrdbus => plb_wrdbus_net,
      radio1_adc_i => radio1_adc_i_net,
      radio1_adc_i_otr => radio1_adc_i_otr_net,
      radio1_adc_q => radio1_adc_q_net,
      radio1_adc_q_otr => radio1_adc_q_otr_net,
      radio1_rssi => radio1_rssi_net,
      radio2_adc_i => radio2_adc_i_net,
      radio2_adc_i_otr => radio2_adc_i_otr_net,
      radio2_adc_q => radio2_adc_q_net,
      radio2_adc_q_otr => radio2_adc_q_otr_net,
      radio2_rssi => radio2_rssi_net,
      radio3_adc_i => radio3_adc_i_net,
      radio3_adc_i_otr => radio3_adc_i_otr_net,
      radio3_adc_q => radio3_adc_q_net,
      radio3_adc_q_otr => radio3_adc_q_otr_net,
      radio3_rssi => radio3_rssi_net,
      radio4_adc_i => radio4_adc_i_net,
      radio4_adc_i_otr => radio4_adc_i_otr_net,
      radio4_adc_q => radio4_adc_q_net,
      radio4_adc_q_otr => radio4_adc_q_otr_net,
      radio4_rssi => radio4_rssi_net,
      sg_plb_addrpref => sg_plb_addrpref_net,
      splb_rst => splb_rst_net,
      startcapture => startcapture_net,
      starttx => starttx_net,
      stoptx => stoptx_net,
      addr => addr_net,
      addr_x0 => addr_x0_net,
      addr_x1 => addr_x1_net,
      addr_x10 => addr_x10_net,
      addr_x11 => addr_x11_net,
      addr_x12 => rx_addr_counter1_op_net_x10,
      addr_x13 => tx_addr_counter_op_net_x2,
      addr_x14 => addr_x14_net,
      addr_x15 => rx_addr_counter1_op_net_x11,
      addr_x16 => tx_addr_counter_op_net_x3,
      addr_x17 => addr_x17_net,
      addr_x18 => rx_addr_counter1_op_net_x12,
      addr_x19 => tx_addr_counter_op_net_x4,
      addr_x2 => addr_x2_net,
      addr_x20 => addr_x20_net,
      addr_x21 => rx_addr_counter1_op_net_x13,
      addr_x22 => tx_addr_counter_op_net_x1,
      addr_x3 => addr_x3_net,
      addr_x4 => addr_x4_net,
      addr_x5 => addr_x5_net,
      addr_x6 => addr_x6_net,
      addr_x7 => addr_x7_net,
      addr_x8 => addr_x8_net,
      addr_x9 => addr_x9_net,
      data_in => data_in_net,
      data_in_x0 => data_in_x0_net,
      data_in_x1 => data_in_x1_net,
      data_in_x10 => data_in_x10_net,
      data_in_x11 => data_in_x11_net,
      data_in_x12 => data_in_x12_net,
      data_in_x13 => data_in_x13_net,
      data_in_x14 => data_in_x14_net,
      data_in_x15 => data_in_x15_net,
      data_in_x16 => data_in_x16_net,
      data_in_x17 => data_in_x17_net,
      data_in_x18 => data_in_x18_net,
      data_in_x19 => data_in_x19_net,
      data_in_x2 => data_in_x2_net,
      data_in_x20 => data_in_x20_net,
      data_in_x21 => data_in_x21_net,
      data_in_x22 => data_in_x22_net,
      data_in_x23 => data_in_x23_net,
      data_in_x24 => data_in_x24_net,
      data_in_x25 => data_in_x25_net,
      data_in_x26 => data_in_x26_net,
      data_in_x27 => data_in_x27_net,
      data_in_x28 => data_in_x28_net,
      data_in_x29 => data_in_x29_net,
      data_in_x3 => data_in_x3_net,
      data_in_x30 => data_in_x30_net,
      data_in_x31 => data_in_x31_net,
      data_in_x32 => rx_addr_counter1_op_net_x9,
      data_in_x33 => data_in_x33_net,
      data_in_x34 => data_in_x34_net,
      data_in_x35 => data_in_x35_net,
      data_in_x36 => data_in_x36_net,
      data_in_x37 => data_in_x37_net,
      data_in_x38 => data_in_x38_net,
      data_in_x39 => data_in_x39_net,
      data_in_x4 => data_in_x4_net,
      data_in_x40 => data_in_x40_net,
      data_in_x41 => data_in_x41_net,
      data_in_x42 => data_in_x42_net,
      data_in_x43 => data_in_x43_net,
      data_in_x44 => data_in_x44_net,
      data_in_x45 => data_in_x45_net,
      data_in_x46 => data_in_x46_net,
      data_in_x47 => data_in_x47_net,
      data_in_x48 => data_in_x48_net,
      data_in_x49 => data_in_x49_net,
      data_in_x5 => data_in_x5_net,
      data_in_x6 => data_in_x6_net,
      data_in_x7 => data_in_x7_net,
      data_in_x8 => data_in_x8_net,
      data_in_x9 => data_in_x9_net,
      debug_agc_done => agc_done_net_x1,
      debug_capturing => debug_capturing_net,
      debug_transmitting => debug_transmitting_net,
      en => en_net,
      en_x0 => en_x0_net,
      en_x1 => en_x1_net,
      en_x10 => en_x10_net,
      en_x11 => en_x11_net,
      en_x12 => en_x12_net,
      en_x13 => en_x13_net,
      en_x14 => en_x14_net,
      en_x15 => en_x15_net,
      en_x16 => en_x16_net,
      en_x17 => en_x17_net,
      en_x18 => en_x18_net,
      en_x19 => en_x19_net,
      en_x2 => en_x2_net,
      en_x20 => convert2_dout_net_x0,
      en_x21 => convert2_dout_net_x1,
      en_x22 => convert2_dout_net_x2,
      en_x23 => convert2_dout_net_x3,
      en_x24 => convert2_dout_net_x4,
      en_x25 => en_x25_net,
      en_x3 => en_x3_net,
      en_x4 => en_x4_net,
      en_x5 => en_x5_net,
      en_x6 => en_x6_net,
      en_x7 => en_x7_net,
      en_x8 => en_x8_net,
      en_x9 => en_x9_net,
      radio1_dac_i => radio1_dac_i_net,
      radio1_dac_q => radio1_dac_q_net,
      radio2_dac_i => radio2_dac_i_net,
      radio2_dac_q => radio2_dac_q_net,
      radio3_dac_i => radio3_dac_i_net,
      radio3_dac_q => radio3_dac_q_net,
      radio4_dac_i => radio4_dac_i_net,
      radio4_dac_q => radio4_dac_q_net,
      rssi_adc_clk => rssi_adc_clk_net,
      sl_addrack => sl_addrack_net,
      sl_rdcomp => sl_rdcomp_net,
      sl_rddack => sl_rddack_net,
      sl_rddbus => sl_rddbus_net,
      sl_wait => sl_wait_net,
      sl_wrcomp => sl_wrdack_x1,
      sl_wrdack => sl_wrdack_x2,
      we => we_net,
      we_x0 => we_x0_net,
      we_x1 => we_x1_net,
      we_x10 => we_x10_net,
      we_x11 => logical_y_net_x10,
      we_x12 => logical_y_net_x11,
      we_x13 => we_x13_net,
      we_x14 => logical_y_net_x12,
      we_x15 => logical_y_net_x13,
      we_x16 => we_x16_net,
      we_x17 => logical_y_net_x14,
      we_x18 => logical_y_net_x15,
      we_x19 => we_x19_net,
      we_x2 => we_x2_net,
      we_x20 => logical_y_net_x16,
      we_x21 => logical_y_net_x17,
      we_x22 => we_x22_net,
      we_x3 => we_x3_net,
      we_x4 => we_x4_net,
      we_x5 => we_x5_net,
      we_x6 => we_x6_net,
      we_x7 => we_x7_net,
      we_x8 => we_x8_net,
      we_x9 => we_x9_net
    );

end structural;
